﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7.8
@EndOfDesignText@
Sub Process_Globals

End Sub


public Sub FindView(pan As Panel, tag As String) As View

	' Find the view on 'Panel' that has tag 'tag'.
	Dim v As View
	Dim vtag As String

	For i = 0 To (pan.NumberOfViews - 1)

		v = pan.GetView(i)
		vtag = v.Tag

		If vtag.EqualsIgnoreCase(tag) Then
			Return v
		End If

	Next

	Return Null

End Sub


Sub GetDeviceId As String

	Dim api As Int
	Dim r As Reflector

	api = r.GetStaticField("android.os.Build$VERSION", "SDK_INT")

	If (api < 9) Then
		'Old device
		If File.Exists(File.DirInternal, "__id") Then
			Return File.ReadString(File.DirInternal, "__id")
		Else
			Dim id As Int
			id = Rnd(0x10000000, 0x7FFFFFFF)
			File.WriteString(File.DirInternal, "__id", id)
			Return id
		End If
	Else
		'New device
		Return r.GetStaticField("android.os.Build", "SERIAL")
	End If

End Sub


Sub GetSDKversion() As String

	Dim p As Phone
	Dim versions As Map

	versions.Initialize
	versions.Put(3, "1.5")
	versions.Put(4, "1.6")
	versions.Put(7, "2.1")
	versions.Put(8, "2.2")
	versions.Put(10, "2.3.3")
	versions.Put(11, "3.0")
	versions.Put(12, "3.1")
	versions.Put(13, "3.2")
	versions.Put(14, "4.0")
	versions.Put(15, "4.0.3")
	versions.Put(16, "4.1")
	versions.Put(17, "4.2")
	versions.Put(18, "4.3")
	versions.Put(19, "4.4")
	versions.Put(20, "4.4W")
	versions.Put(21, "5.0")
	versions.Put(22, "5.1")
	versions.Put(23, "6.0")
	versions.Put(24, "7.0")
	versions.Put(25, "7.1")

	Return p.SdkVersion & " (" & versions.Get(p.SdkVersion) & ")"

End Sub


public Sub IIf(condition As Boolean, trueRes As Object, falseRes As Object) As Object

	If condition Then
		Return trueRes
	Else
		Return falseRes
	End If

End Sub


public Sub IndexOfLineEnd(text As String, start As Int) As Int

	' Find the next end-of-line character, starting at index 'start'.
	' Return -1 if none found.
	If (text.Length = 0) Then
		Return -1
	End If

	If (start >= text.Length) Then
		Return -1
	End If

	For i = start To (text.Length - 1)

		Select text.CharAt(i)
			Case Chr(10)
				Return i
		End Select

	Next

	Return -1

End Sub


public Sub IsToday(time As Long) As Boolean
	
	Return DateUtils.IsSameDay(time, DateTime.Now)

End Sub


public Sub List2String(a_list As List, separator As String) As String

	Dim result As String

	For Each line As String In a_list
		result = result & line & separator
	Next

	Return result

End Sub


public Sub LookupTest(classes As List, className As String, methodName As String) As TestMethodInfoType

	' Lookup 'className'/'methodName' in 'classes' (a List of 'TestClassInfoType').
	Dim aClass As TestClassInfoType = Null

	For Each class As TestClassInfoType In classes

		If class.ClassName.EqualsIgnoreCase(className) Then
			aClass = class
			Exit
		End If

	Next

	If (aClass = Null) Then
		Log("ERROR - No such class: " & className)
		Return Null
	End If

	For Each method As TestMethodInfoType In class.Methods

		If method.MethodName.EqualsIgnoreCase(methodName) Then
			Return method
		End If

	Next

	Log("ERROR - No such method in class " & className & ": " & methodName)
	Return Null

End Sub


public Sub SplitTextLines(text As String, trimLines As Boolean) As List

	Dim result As List
	result.Initialize

	If (text = "") Then Return result

	Dim endPos As Int = 0
	Dim line As String
	Dim pos As Int = 0

	Do While (pos <= text.Length - 1)

		' Find the end of this line, i.e. the next end-of-line or the end of the text.
		endPos = IndexOfLineEnd(text, pos)

		If (endPos < 0) Then
			' End of the text.
			line = text.SubString(pos)
			If trimLines Then line = line.trim
			result.Add(line)
			Exit
		End If

		line = text.SubString2(pos, endPos)
		If trimLines Then line = line.trim
		result.Add(line)

		pos = endPos + 1

	Loop

	Return result

End Sub

