﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Private ColSeparation As Int
	Private ColWidths(10) As Int
	Private FailsOnly As Boolean
	Private NativeMe As JavaObject
	Private RelColWidths(10) As Int
	Private RowHeight As Int
	Private TestClasses As List					' list of TestClassInfoType
	Private TR As CTestRunner

	Private const COL_INCLUDE As Int = 0
	Private const COL_CLASS As Int = 1
	Private const COL_METHOD As Int = 2
	Private const COL_RESULT As Int = 3
	Private const COL_RUN As Int = 4
	Private const COL_TIME As Int = 5
	Private const COL_INFO As Int = 6

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private Button1 As Button
	Private Button2 As Button
	Private CheckBox1 As CheckBox
	Private CLV1 As CustomListView
	Private StatusLabel As Label

	Private Button3 As Button
End Sub


Sub Activity_Create(FirstTime As Boolean)

	If FirstTime Then
		Log("Creating Activity 'UnitTest1' (first time)")
		NativeMe.InitializeContext

		Starter.Debugging = NativeMe.RunMethod("Debugging", Null)
		Starter.LegacyDebugging = NativeMe.RunMethod("LegacyDebugging", Null)
		Log("Debugging: " & Starter.Debugging)
		Log("Legacy Debugging: " & Starter.LegacyDebugging)

		TR = Starter.TestRunner
		TR.NativeActivity = NativeMe

		ColSeparation = 10dip
		FailsOnly = False
		RowHeight = 34dip
		RelColWidths(COL_INCLUDE) = 40
		RelColWidths(COL_CLASS) = 300
		RelColWidths(COL_METHOD) = 300
		RelColWidths(COL_RESULT) = 34
		RelColWidths(COL_RUN) = 120
		RelColWidths(COL_TIME) = 80
		RelColWidths(COL_INFO) = 400

		TestClasses = DiscoverTests("ctest", "test_", 2)
		LoadState(TestClasses)
	Else
		Log("Creating Activity 'UnitTest1'")
	End If

	Activity.LoadLayout("UnitTest1_Layout1")
	Resize

	LoadListView(TestClasses)
	UpdateStatus(TestClasses)

End Sub


Sub Activity_Pause (UserClosed As Boolean)

End Sub


Sub Activity_Resume

End Sub


Sub AddDataRow(y As Int, method As TestMethodInfoType) As Int

	' Add a data row to the Tests list view.
	' Returns the next Y value.
	Dim class As TestClassInfoType = method.Class
	Dim s As String
	Dim x As Int = 0

	' Add a panel.
	Dim pan As Panel
	pan.Initialize("")
	pan.Top = y
	pan.Color = Colors.Black
	pan.Tag = method
	CLV1.Add(pan, RowHeight, Null)

	' 'Include' column - use a checkbox.
	Dim chkInclude As CheckBox
	chkInclude.Initialize("Test_CheckBox")
	chkInclude.Checked = method.Include
	chkInclude.Tag = "Include"
	pan.AddView(chkInclude, 0, 0, ColWidths(COL_INCLUDE), RowHeight)
	x = x + chkInclude.Width + ColSeparation

	' 'Class' column - use a label.
	x = AddLabel(pan, x, ColWidths(COL_CLASS), RowHeight, class.ClassName, "")

	' 'Sub' column - use a label.
	x = AddLabel(pan, x, ColWidths(COL_METHOD), RowHeight, method.MethodName, "")

	' 'Last Result' column - use an image.
	Dim imgFile As String = ""

	Select method.LastResult.ToLowerCase
		Case "fail"
			imgFile = "fail.png"
		Case "pass"
			imgFile = "pass.png"
	End Select

	Dim imgResult As ImageView
	imgResult.Initialize("")
	imgResult.Gravity = Gravity.CENTER_VERTICAL
	If (imgFile <> "") Then imgResult.Bitmap = LoadBitmap(File.DirAssets, imgFile)
	imgResult.Tag = "Last Result"
	pan.AddView(imgResult, x, 0, ColWidths(COL_RESULT), RowHeight)
	x = x + imgResult.Width + ColSeparation

	' 'Last Run' column - use a label.
	s = TestUtils.IIf(method.LastRun = 0, "", _
		TestUtils.IIf(TestUtils.IsToday(method.LastRun), DateTime.Time(method.LastRun), DateTime.Date(method.LastRun)))
	x = AddLabel(pan, x, ColWidths(COL_RUN), RowHeight, s, "Last Run")

	' 'Last Time (in ms)' column - use a label.
	s = TestUtils.IIf(method.LastRun = 0, "", method.LastTime)
	x = AddLabel(pan, x, ColWidths(COL_TIME), RowHeight, s, "Last Time")

	' 'Info' column - use a label.
	s = ""
	If (method.LastRun > 0) Then s = method.Info
	x = AddLabel(pan, x, ColWidths(COL_INFO), RowHeight, s, "Info")

	Return y + RowHeight

End Sub


Sub AddHeaderRow(y As Int) As Int

	' Add a header row to the Tests list view.
	' Returns the next Y value.
	Dim ht As Int = RowHeight * 1.2
	Dim x As Int = 0

	' A panel.
	Dim pan As Panel
	pan.Initialize("")
	pan.Top = y
	pan.Color = Colors.Blue
	CLV1.Add(pan, ht, Null)

	' 'Include' column.
	Dim chkInclude As CheckBox
	chkInclude.Initialize("Header_CheckBox")
	chkInclude.Checked = True
	'chkInclude.Gravity = Gravity.CENTER_VERTICAL
	chkInclude.Tag = "Include"
	pan.AddView(chkInclude, 0, 3dip, ColWidths(COL_INCLUDE), RowHeight)
	x = x + chkInclude.Width + ColSeparation

	' 'Class' column.
	x = AddLabel(pan, x, ColWidths(COL_CLASS), ht, "Class", "")

	' 'Sub' column.
	x = AddLabel(pan, x, ColWidths(COL_METHOD), ht, "Sub", "")

	' 'Last Result' column.
	x = AddLabel(pan, x, ColWidths(COL_RESULT), ht, "", "")

	' 'Last Run' column.
	x = AddLabel(pan, x, ColWidths(COL_RUN), ht, "Run", "")

	' 'Last Time (in ms)' column.
	x = AddLabel(pan, x, ColWidths(COL_TIME), ht, "Time", "")

	' 'Info' column.
	x = AddLabel(pan, x, ColWidths(COL_INFO), ht, "Info", "")

	Return y + ht

End Sub


Sub AddLabel(pan As Panel, x As Int, width As Int, height As Int, text As String, tag As String) As Int

	' Add a label to 'pan' in the Tests list view.
	' Returns the next X value.
	Dim lab As Label
	lab.Initialize("")
	lab.Gravity = Gravity.CENTER_VERTICAL
	lab.SingleLine = True
	lab.Tag = tag
	lab.Text = text

	pan.AddView(lab, x, 0, width, height)

	Return x + lab.Width + ColSeparation

End Sub


Sub Button1_Click

	SaveState(TestClasses)
	Activity.Finish

End Sub


Sub Button2_Click

	' 'Run Tests' button.
	SaveListView(TestClasses)

	RunTests(TestClasses, "ctest", "ctest_", "test_", 9)

	UpdateStatus(TestClasses)
	UpdateListView(TestClasses)

	ToastMessageShow("Tests finished", True)

End Sub


Sub Button3_Click

	' 'Print' button.
	SaveHtmlReport

End Sub


Sub CheckBox1_CheckedChange(Checked As Boolean)

	' 'Fails only' checkbox.
	FailsOnly = Checked
	LoadListView(TestClasses)

End Sub


Sub CLV1_ItemClick(Index As Int, Value As Object)

	Dim pan As Panel = CLV1.GetPanel(Index)
	If (pan = Null) Then Return

	Dim method As TestMethodInfoType = pan.Tag
	If (method = Null) Then Return
	If StringHelpers.IsNullOrWhitespace(method.Info) Then Return

	Dim s As String = method.Info.Replace("|", CRLF)
	ToastMessageShow(s, True)

End Sub


Sub DiscoverTests(classPrefix As String, methodPrefix As String, verbosity As Int) As List

	' Returns a List of 'TestClassInfoType'.
	Log("DiscoverTests: verbosity " & verbosity)

	Dim saveVerbosity As Int = TR.Verbosity
	TR.Verbosity = verbosity

	Dim result As List = TR.Discover(classPrefix, methodPrefix)

	TR.Verbosity = saveVerbosity

	Return result

End Sub


Sub Header_CheckBox_CheckedChange(Checked As Boolean)

	Dim chk As CheckBox = Sender
	Log("Header_CheckBox: " & Checked & ", " & chk.Tag)

	If Checked Then
		' Not checked -> Checked - include all visible Tests.
		SetInclude(TestClasses, True)
	Else
		' Checked -> Not checked - exclude all visible Tests.
		SetInclude(TestClasses, False)
	End If

	UpdateStatus(TestClasses)
	UpdateListView(TestClasses)

End Sub


Sub LoadListView(classes As List) As Boolean

	' Load the Tests list view from 'classes' (a List of 'TestClassInfoType').
	Log("LoadListView")
	CLV1.Clear

	Dim failed As Boolean
	Dim y As Int = 0

	y = AddHeaderRow(y)

	For Each class As TestClassInfoType In classes
		For Each method As TestMethodInfoType In class.Methods

			failed = (method.LastRun > 0) And method.LastResult.EqualsIgnoreCase("fail")
			If FailsOnly And Not(failed) Then Continue

			y = AddDataRow(y, method)

		Next
	Next

	Return True

End Sub


Sub LoadState(classes As List) As Boolean

	' Load the saved Test state from last time from a file in 'DirAssets', if present.
	Try
		Dim filename As String = "unit_tests.csv"
		Dim folder As String = File.DirDefaultExternal

		Log("LoadState: folder: " & folder & ", file: " & filename)

		If Not(File.Exists(folder, filename)) Then
			Log("WARNING - File not found in '" & folder & "': " & filename)
			Return True
		End If

		' Read the file.
		Dim s As String = File.ReadString(folder, filename)

		Dim className As String
		Dim count As Int = 0
		Dim fields As List
		Dim info As String
		Dim lastResult As String
		Dim lastRun As Long
		Dim lastTime As Int
		Dim lines As List = TestUtils.SplitTextLines(s, True)
		Dim methodName As String

		For Each line As String In lines

			fields = StringHelpers.SplitText(line, 10, False, True)

			If (fields.Size < 6) Then
				Log("ERROR - Invalid line in " & filename & ": " & line)
				Continue
			End If

			className = fields.Get(0)
			methodName = fields.Get(1)
			lastResult = fields.Get(2)
			lastRun = fields.Get(3)
			lastTime = fields.Get(4)
			info = fields.Get(5)

			UpdateItem(classes, className, methodName, lastResult, lastRun, lastTime, info)
			count = count + 1

		Next

		Log(count & " valid lines read from file: " & filename)
	Catch
		Log("ERROR - " & LastException.Message)
		Return False
	End Try

	Return True

End Sub


Sub Resize As Boolean

	Log("Resize: CLV1 is " & CLV1.sv.Width & " x " & CLV1.sv.Height)
	Dim totalRelWidth As Int = 0

	For col = COL_INCLUDE To COL_INFO
		totalRelWidth = totalRelWidth + RelColWidths(col)
		If (col < COL_INFO) Then totalRelWidth = totalRelWidth + ColSeparation
	Next

	For col = COL_INCLUDE To COL_INFO
		ColWidths(col) = RelColWidths(col) * CLV1.sv.Width / totalRelWidth
	Next

	Return True

End Sub


Sub RunTests(classes As List, baseClass As String, classPrefix As String, methodPrefix As String, verbosity As Int)

	' Test all Classes beginning with 'classPrefix' / all Subs beginning with 'methodPrefix'.
	' 'classes' is a List of 'TestClassInfoType'.
	Log("RunTests: verbosity " & verbosity)

	Dim saveVerbosity As Int = TR.Verbosity
	TR.Verbosity = verbosity

	TR.RunAll(classes, baseClass, classPrefix, methodPrefix, FailsOnly)

	TR.Verbosity = saveVerbosity

End Sub


Sub SaveHtmlReport As Boolean

	Dim reporter As CTestReporter_Html
	reporter.Initialize

	Dim filename As String = "test report.html"
	Dim folder As String = File.DirDefaultExternal

	Log("SaveHtmlReport: folder: " & folder & ", file: " & filename)

	Dim html As String = reporter.CreateReport(TestClasses)

	File.WriteString(folder, filename, html)

	ToastMessageShow("HTML report saved to: " & folder & ", " & filename, True)

	Return True

End Sub


Sub SaveListView(classes As List) As Boolean

	' Save the Tests list view, to capture the User's 'Include' wishes.
	' 'classes' is a List of 'TestClassInfoType'.
	Log("SaveListView")
	Dim chk As CheckBox

	For i = 0 To (CLV1.GetSize - 1)

		Dim pan As Panel = CLV1.GetPanel(i)
		Dim method As TestMethodInfoType = pan.Tag

		If (method <> Null) Then
			chk = TestUtils.FindView(pan, "Include")

			If (chk <> Null) Then
				method.Include = chk.Checked
			End If
		End If

	Next

	Return True

End Sub


Sub SaveState(classes As List) As Boolean

	' Save the Test state to file in 'DirAssets', ready for next time.
	' 'classes' is a List of 'TestClassInfoType'.
	If Not(File.ExternalWritable) Then
		Log("ERROR - Cannot write Test state to SD card")
		Return False
	End If

	Try
		Dim filename As String = "unit_tests.csv"
		Dim folder As String = File.DirDefaultExternal
		Dim s As String

		Log("SaveState: folder: " & folder & ", file: " & filename)

		For Each class As TestClassInfoType In classes
			For Each method As TestMethodInfoType In class.Methods

				s = s & class.ClassName & " " & method.MethodName & " " & method.LastResult & " " & method.LastRun _
					& " " & method.LastTime & " """ & method.Info & """" & CRLF

			Next
		Next

		File.WriteString(folder, filename, s)

		ToastMessageShow("Saved to: " & folder & ", " & filename, True)
	Catch
		Log("ERROR - " & LastException.Message)
		Return False
	End Try

	Return True

End Sub


Sub SetInclude(classes As List, state As Boolean) As Boolean

	' Set all visible Test methods in 'classes' to 'Include' = 'state'.
	Dim visible As Boolean

	For Each class As TestClassInfoType In classes
		For Each method As TestMethodInfoType In class.Methods

			visible = Not(FailsOnly) Or ((method.LastRun > 0) And method.LastResult.EqualsIgnoreCase("fail"))
			If visible Then method.Include = state

		Next
	Next

	Return True

End Sub


Sub Test_CheckBox_CheckedChange(Checked As Boolean)

	Dim chk As CheckBox = Sender
	'Log("Test_CheckBox_CheckedChange: " & Checked & ", " & chk.Tag)

	Try
		' Get the panel that has this checkbox.
		Dim pan As Panel = chk.Parent
		If (pan = Null) Then Return
		If Not(pan.IsInitialized) Then Return

		Dim method As TestMethodInfoType = pan.Tag
		method.Include = Checked

		UpdateStatus(TestClasses)
	Catch
		Log("ERROR - Test_CheckBox_CheckedChange: " & LastException.Message)
	End Try

End Sub


Sub UpdateDataRow(pan As Panel, method As TestMethodInfoType) As Boolean

	' Update the views in 'pan' from 'method'.
	Dim aTag As String
	Dim chk As CheckBox
	Dim img As ImageView
	Dim lab As Label
	Dim s As String
	Dim v As View

	For i = 0 To (pan.NumberOfViews - 1)

		v = pan.GetView(i)
		aTag = v.Tag

		Select Case aTag.ToLowerCase

			Case "include"
				' Update the 'Include' cell.
				chk = v
				chk.Checked = method.Include

			Case "last result"
				' Update the 'Last Result' cell.
				img = v
				Dim imgFile As String = ""
				
				Select method.LastResult.ToLowerCase
					Case "fail"
						imgFile = "fail.png"
					Case "pass"
						imgFile = "pass.png"
				End Select
				
				If (imgFile <> "") Then img.Bitmap = LoadBitmap(File.DirAssets, imgFile)

			Case "last run"
				' Update the 'Last Run' cell.
				lab = v
				s = TestUtils.IIf(method.LastRun = 0, "", _
					TestUtils.IIf(TestUtils.IsToday(method.LastRun), DateTime.Time(method.LastRun), DateTime.Date(method.LastRun)))
				lab.Text = s

			Case "last time"
				' Update the 'Last Time (in ms)' cell.
				lab = v
				s = TestUtils.IIf(method.LastRun = 0, "", method.LastTime)
				lab.Text = s

			Case "info"
				' Update the 'Info' cell.
				lab = v
				s = ""
				If (method.LastRun > 0) Then s = method.Info.Replace("|", CRLF)
				lab.Text = s

		End Select

	Next

	Return True

End Sub


Sub UpdateItem(classes As List, className As String, methodName As String, lastResult As String, _
	lastRun As Long, lastTime As Int, info As String) As Boolean

	' Update the test 'className' / 'methodName' from 'lastResult', 'lastRun', 'lastTime' and 'info'.
	' 'classes' is a List of 'TestClassInfoType'.
	Dim method As TestMethodInfoType = TestUtils.LookupTest(classes, className, methodName)
	If (method = Null) Then Return False

	method.LastResult = lastResult
	method.LastRun = lastRun
	method.LastTime = lastTime	
	method.Info = info

	Return True

End Sub


Sub UpdateListView(classes As List) As Boolean

	' Update the Tests list view from 'classes' (a List of 'TestClassInfoType').
	Log("UpdateListView")

	' Update the list view rows.
	Dim failed As Boolean
	Dim method As TestMethodInfoType
	Dim pan As Panel

	For i = 0 To (CLV1.GetSize - 1)

		pan = CLV1.GetPanel(i)

		If (pan.Tag <> Null) Then
			method = pan.Tag
			failed = (method.LastRun > 0) And method.LastResult.EqualsIgnoreCase("fail")
			If FailsOnly And Not(failed) Then Continue

			UpdateDataRow(pan, method)
		End If

	Next

	Return True

End Sub


Sub UpdateStatus(classes As List) As Boolean

	' Update the Status label from 'classes' (a List of 'TestClassInfoType').
	dim failed as Boolean
	Dim nTests As Int = 0
	Dim nTestsFailed As Int = 0
	Dim nTestsIncluded As Int = 0
	Dim nTestsPassed As Int = 0

	For Each class As TestClassInfoType In classes

		For Each method As TestMethodInfoType In class.Methods

			failed = (method.LastRun > 0) And method.LastResult.EqualsIgnoreCase("fail")
			If FailsOnly And Not(failed) Then Continue

			nTests = nTests + 1

			If (method.Include) Then
				nTestsIncluded = nTestsIncluded + 1

				If (method.LastRun > 0) Then
					If method.LastResult.EqualsIgnoreCase("pass") Then
						nTestsPassed = nTestsPassed + 1
					Else
						nTestsFailed = nTestsFailed + 1
					End If
				End If
			End If

		Next

	Next

	Dim s As String = nTests & " tests, "

	If (nTestsIncluded = 0) Then
		s = s & "all excluded"
	Else
		If (nTestsIncluded = nTests) Then
			s = s & "all included, "
		Else
			s = s & nTestsIncluded & " included, "
		End If

		If (nTestsPassed = nTestsIncluded) And (nTestsFailed = 0) Then
			s = s & "ALL PASSED"
		Else
			s = s & nTestsPassed & " passed, " & nTestsFailed & " failed"
		End If
	End If

	StatusLabel.Text = s

	Return True

End Sub



#if JAVA
	public boolean Debugging()
	{
		return BA.debugMode;
	}

	public String GetPackageCodePath()
	{
		return getPackageCodePath();
	}

	public Object GetProcessBA()
	{
		return processBA;
	}

	public boolean LegacyDebugging()
	{
		return BA.debugMode && !BA.shellMode;		// BA.isShellModeRuntimeCheck(ba);
	}
#End If


